searchNodes=[{"ref":"SlackDB.html","title":"SlackDB","type":"module","doc":"GenServer that is responsible for all interactions with SlackDB. On startup, the server will load into memory the current state of the server (as described in the supervisor channel). All changes to state (channel additions and archivals) made through this API will be updated and persisted in the supervisor channel"},{"ref":"SlackDB.html#append/4","title":"SlackDB.append/4","type":"function","doc":"Appends values to the current thread of the key (maintaining history) You can use this to append to the list of keys with type :multiple. Or to add voting options to :voting keys. Or to change the value of :single_back keys This function returns an error tuple or a list of tuples indicating the result of posting each value. Example iex&gt; SlackDB.append(&quot;dog_shelter&quot;, &quot;adopted&quot;, &quot;Chihuahuas&quot;, &quot;Ren&quot;) [ ok: %{ &quot;channel&quot; =&gt; &quot;CHU427918&quot;, &quot;message&quot; =&gt; %{...}, &quot;ok&quot; =&gt; true, &quot;ts&quot; =&gt; &quot;1556129092.000800&quot; } ]"},{"ref":"SlackDB.html#archive_channel/2","title":"SlackDB.archive_channel/2","type":"function","doc":"Archives a channel and removes it from the state of the database Example iex&gt; SlackDB.archive_channel(&quot;dog_shelter&quot;, &quot;coops-winter-2019&quot;) {:ok, &quot;channel archived&quot;}"},{"ref":"SlackDB.html#child_spec/1","title":"SlackDB.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"SlackDB.html#create/6","title":"SlackDB.create/6","type":"function","doc":"Create a key/value pair in the specified server and channel of the given type This essentially overwrites the key if it already exist. It posts a new message that will always be prioritized by read/4 because it is more recent. The value passed in may be either a String or a list of Strings that will be posted in the key&#39;s thread, in order. You can specify additional metadata to be added to the key using an optional list. This function returns an error tuple or a list of tuples indicating the result of posting each value. The channel that is specified must exist in the scope of the server. ## Example iex&gt; SlackDB.create(&quot;dog_shelter&quot;, &quot;adopted&quot;, &quot;Beagles&quot;, [&quot;Buddy&quot;, &quot;Rufus&quot;], :multiple, [:undeletable]) [ ok: %{ &quot;channel&quot; =&gt; &quot;CHU427918&quot;, &quot;message&quot; =&gt; %{...}, &quot;ok&quot; =&gt; true, &quot;ts&quot; =&gt; &quot;1556129092.000800&quot; }, ok: %{ &quot;channel&quot; =&gt; &quot;CHU427918&quot;, &quot;message&quot; =&gt; %{...}, &quot;ok&quot; =&gt; true, &quot;ts&quot; =&gt; &quot;1556129093.001000&quot; } ]"},{"ref":"SlackDB.html#delete/3","title":"SlackDB.delete/3","type":"function","doc":"Deletes a key and it&#39;s associated thread Beware of rate_limiting issues discussed in the README This function returns an error tuple or a list of tuples indicating the result of deleting each message in the thread. Example iex&gt; SlackDB.delete(&quot;dog_shelter&quot;, &quot;yet-to-be-adopted&quot;, &quot;Chihuahuas&quot;) [ ok: %{ &quot;channel&quot; =&gt; &quot;CHU427918&quot;, &quot;message&quot; =&gt; %{...}, &quot;ok&quot; =&gt; true, &quot;ts&quot; =&gt; &quot;1556129092.000800&quot; }, ]"},{"ref":"SlackDB.html#dump/0","title":"SlackDB.dump/0","type":"function","doc":"Returns a map representing the current state of the database Example iex&gt; SlackDB.dump() %{ &quot;dog_shelter&quot; =&gt; %{ bot_name: &quot;Jeanie&quot;, bot_token: &quot;xoxb-shhh...&quot;, user_token: &quot;xoxp-shhh...&quot; channels: %{ &quot;adopted&quot; =&gt; &quot;CHU427918&quot;, &quot;yet-to-be-adopted&quot; =&gt; &quot;CJ57Z7QS1&quot; }, supervisor_channel_id: &quot;CFC6MRQ06&quot;, supervisor_channel_name: &quot;slackdb-admin&quot;, } }"},{"ref":"SlackDB.html#include_channel/2","title":"SlackDB.include_channel/2","type":"function","doc":"Includes an existing channel and updates the state of the database A channel must exist in the current state of the databse to create keys or to invite users Since bots cannot add themselves to channels, you must also add the bot manually once the channel is included. Example iex&gt; SlackDB.include_channel(&quot;dog_shelter&quot;, &quot;employees&quot;) {:ok, &quot;channel added&quot;}"},{"ref":"SlackDB.html#invite_supervisors/2","title":"SlackDB.invite_supervisors/2","type":"function","doc":"Invites a user_id or a list of user_ids to the supervisor channel of a specified server Example iex&gt; SlackDB.invite_supervisors(&quot;dog_shelter&quot;, [&quot;USERID1&quot;, &quot;USERID2&quot;]) {:ok, %{&quot;name&quot; =&gt; &quot;adopted&quot;, &quot;id&quot; =&gt; &quot;CHU427918&quot;}}"},{"ref":"SlackDB.html#invite_to_channel/3","title":"SlackDB.invite_to_channel/3","type":"function","doc":"Invites a user_id or a list of user_ids to a specified channel Example iex&gt; SlackDB.invite_to_channel(&quot;dog_shelter&quot;, &quot;adopted&quot;, [&quot;USERID1&quot;, &quot;USERID2&quot;]) {:ok, %{&quot;name&quot; =&gt; &quot;adopted&quot;, &quot;id&quot; =&gt; &quot;CHU427918&quot;}}"},{"ref":"SlackDB.html#new_channel/3","title":"SlackDB.new_channel/3","type":"function","doc":"Creates a new channel and updates the current state of the database A channel must exist in the current state of the databse to create keys or to invite users. Since bots cannot add themselves to channels, you must also add the bot manually once the channel is created. Example iex&gt; SlackDB.new_channel(&quot;dog_shelter&quot;, &quot;volunteers&quot;, false) {:ok, &quot;channel added&quot;}"},{"ref":"SlackDB.html#read/4","title":"SlackDB.read/4","type":"function","doc":"Reads a key in the given server and channel This will always pull from the most recently posted message that matches the key schema. Setting only_bot? to true will search only for keys posted under the bot name specified in the config. Example iex&gt; SlackDB.read(&quot;dog_shelter&quot;, &quot;adopted&quot;, &quot;Beagles&quot;) {:ok, [&quot;Buddy&quot;, &quot;Rufus&quot;]}"},{"ref":"SlackDB.html#read!/4","title":"SlackDB.read!/4","type":"function","doc":"Reads a key in the given server and channel, raising an error if anything went wrong This will always pull from the most recently posted message that matches the key schema. Setting only_bot? to true will search only for keys posted under the bot name specified in the config. Example iex&gt; SlackDB.read!(&quot;dog_shelter&quot;, &quot;adopted&quot;, &quot;Beagles&quot;) [&quot;Buddy&quot;, &quot;Rufus&quot;]"},{"ref":"SlackDB.html#start_link/0","title":"SlackDB.start_link/0","type":"function","doc":"Start genserver, pull server config from application environment and pass to init/1"},{"ref":"SlackDB.html#update/4","title":"SlackDB.update/4","type":"function","doc":"Overwrites the current value of the key by deleting the current thread and posting new values (sacrificing rollback) This is the only way to change the value of a :single_front key. This function returns an error tuple or a list of tuples indicating the result of posting each value. Example iex&gt; SlackDB.update(&quot;dog_shelter&quot;, &quot;adopted&quot;, &quot;Chihuahuas&quot;, &quot;Ren&quot;) [ ok: %{ &quot;channel&quot; =&gt; &quot;CHU427918&quot;, &quot;message&quot; =&gt; %{...}, &quot;ok&quot; =&gt; true, &quot;ts&quot; =&gt; &quot;1556129092.000800&quot; }, ]"},{"ref":"SlackDB.html#t:key_type/0","title":"SlackDB.key_type/0","type":"type","doc":"Types of SlackDB keys represented as atoms Types :voting - replies to keys are treated as a ballot where reactions represent support for that particular value. winner takes all. :multiple - the reply thread represents an array that is returned in full and in chronological order :single_front - the first reply to the key is the value :token_scopes - the most recent reply to the key is the value"},{"ref":"SlackDB.html#t:more_metadata/0","title":"SlackDB.more_metadata/0","type":"type","doc":"More key metadata options represented as atoms Types :constant - key cannot changed after creation (save for deletion) :undeletable - key cannot be deleted (through this API)"},{"ref":"SlackDB.html#t:value/0","title":"SlackDB.value/0","type":"type","doc":"Represents the types of values that keys can hold. Since all values are stored in Slack, they are all returned as strings (or a list of strings in the case of key_type :multiple)"},{"ref":"SlackDB.Key.html","title":"SlackDB.Key","type":"module","doc":"A struct that holds all required information for a SlackDB key"},{"ref":"SlackDB.Key.html#t:t/0","title":"SlackDB.Key.t/0","type":"type","doc":"A map containing the necessary attributes to identify keys uniquely"},{"ref":"README.md.html","title":"SlackDB","type":"extras","doc":"SlackDB A key/value database courtesy of Slack 🙃. This is not a joke. SlackDB is a middleperson between Slack and your Slack app that facilitates the orchestration of Slack channels across multiple workspaces as a k/v database. SlackDB is highly interactive and it natively supports array storage, rollbacks, and democracy. All 😈 powered 😈 by 😈 the 😈 cloud. The benefits of using slack as a database are: Slack covers the compute Slack covers the persistent storage You can allow users to vote on values using reactions Native support for arrays through Slack&#39;s reply threads Roll back 😉 changes by deleting messages Absolutely free SlackDB is be extremely useful for Slack apps that need persistant storage but can&#39;t justify spinning up an entire database. Obviously, it isn&#39;t as performant as a dedicated database but it&#39;s easy to use, free (in just about every sense), and has a few unique interactability features."},{"ref":"README.md.html#how","title":"SlackDB - How?","type":"extras","doc":"Messages are keys and replies are values. Emojis represent metadata. Key Types and Metadata Built into SlackDB are 4 basic key types: 👍 votable -- treat the replies to a key as a ballot where reactions represent support for that particular value. winner takes all. 👪 multiple -- treat the entire reply thread as an array 🙉 single value push front -- treat the very first reply in the thread as the value 🐒 single value push back -- treat the most recent reply in the thread as the value More Metadata SlackDB also offers the following additional metadata options that can simply be appended to the key message: 🚯 constant -- don&#39;t allow the key to be edited via update/append commands ⚓ undeletable -- don&#39;t allow the key to be deleted"},{"ref":"README.md.html#installation","title":"SlackDB - Installation","type":"extras","doc":"Add the :slackdb dependency to your mix.exs file: def deps do [ {:slackdb, &quot;~&gt; 0.1.0&quot;} ] end Then, run mix deps.get in your shell to fetch the new dependency."},{"ref":"README.md.html#configuration","title":"SlackDB - Configuration","type":"extras","doc":"Before startup, you&#39;ll need to: Create a (private) supervisor channel on each server on which you want to use SlackDB Add your app&#39;s bot user to that channel Record the channel&#39;s name and ID This channel is responsible for storing the current state (meaning a map of channel names-&gt;ids that are currently &#39;registered&#39;) of the database on that particular server. On startup, SlackDB will look in this channel and load the current state. If it can&#39;t find the current state, it will start from scratch assuming no channels have yet to be registered with the DB Your app needs to have the following scopes to get full SlackDB functionality: search:read, chat.delete, channels:write, groups:write, channels:read, groups:read, reactions:read, channels:history Once you have your supervisor channels, fill out the config like so: config :slackdb, servers: %{ &quot;server_name&quot; =&gt; %{ bot_token: &quot;xoxb-shhh...&quot;, user_token: &quot;xoxp-shhh...&quot;, bot_name: &quot;Jeanie&quot;, supervisor_channel_name: &quot;sladckdb-admin&quot;, supervisor_channel_id: &quot;CFC6MRQ06&quot; } # &quot;server2&quot; =&gt; %{...} }"},{"ref":"README.md.html#usage","title":"SlackDB - Usage","type":"extras","doc":"It&#39;s pretty simple. Here is an example from the command line: iex&gt; {:ok, pid} = SlackDB.start_link() iex&gt; SlackDB.dump() %{ &quot;server_name&quot; =&gt; %{ bot_token: &quot;xoxb-shhh...&quot;, user_token: &quot;xoxp-shhh...&quot;, bot_name: &quot;Jeanie&quot;, supervisor_channel_name: &quot;sladckdb-admin&quot;, supervisor_channel_id: &quot;CFC6MRQ06&quot;, channels: %{&quot;loaded_from&quot; =&gt; &quot;supervisor_channel&quot;} } You&#39;ll notice how the server config has an additional key, :channels, which was loaded from the supervisor channel on startup. If this is your first time starting up SlackDB and nothing is in the supervisor channel, it&#39;ll be an empty map. At this point you can use the CRUDA (CRUD + Append) interface for interacting with the database. You can create new channels or include existing channels through the API and their respective supervisor channels will automatically be updated with the new state. Note that SlackDB can read from any channel that the user token has access to but it can only write to channels that the bot user is in."},{"ref":"README.md.html#notes-on-limitations","title":"SlackDB - Notes on Limitations","type":"extras","doc":"Rate limiting The update and delete commands require deleting an entire thread of messages. They do it by calling Slack&#39;s chat.delete endpoint on each message in the thread (concurrently). This endpoint has Tier 3 rate limiting which means it can only handle ~50 calls per minute. Threads with over 50 replies may be at risk of not being fully deleted. Search delay Recently posted messages won’t be available to search for a few seconds. Creating a key and then reading it won’t work until ~5 seconds after the key was posted. Vulnerability to nasty users Users are able to interact with SlackDB channels by reacting, adding keys, and adding values. Nasty Users could try to fuck with you by: Posting duplicate keys Posting values that fit the key schema which would increase the search/processing time and, in some cases, cause SlackDB to hurt itself in confusion 🐤🐤🐤. SlackDB attempts to mitigate these issues by giving you the option to only recognise keys posted by the bot user. Replies from real users that match the key schema will no longer be an issue. Additionally, you can always use private channels to control which users have access to the DB. In the future, this could be handled using a dedicated HTTP server and the Events API which could screen incoming posts from real users and filter out the sketchy ones. Bot user limitations Bots can&#39;t invite themselves to channels 😞. Whenever you add a new channel or include an existing one to the database, you&#39;re going to need to invite the bot user so it can post messages This is actually a fairly simple problem to solve since we can use the user token to invite the bot. Unfortunately, Slack&#39;s Web API doesn&#39;t make it easy to retrieve bot IDs. You&#39;ll need to paginate through users.list and look for the bot. (In fact, this process could happen on startup and then be loaded into the GenServer state). peep the Issues on this repo"}]